//header for access-function
#if !defined(AFX_ACCESS)
#define AFX_ACCESS


    #define DllExport  extern "C" __declspec( dllexport )

    #include "defs.h"

        // search for ICType and return pointer or NULL
        DllExport TICInfo* GetICInfo(WORD ICType);

        //create a TICInfo-object 
        DllExport TICInfo* MallocICMem();

        // return Type, which is set by SetICType()
        DllExport WORD GetICType();

        // add an new Def (pNext-pointer can be uninitialized)
        // USE:  pNew=new(TICInfo);
        //       fill pNew-struct and call AddIcDefinition(pNew);
        // NOTE: pNew will be deleted, if EXE terminates
        DllExport BOOL AddIcDefinition(TICInfo *pNew);

        // return chsum of given MEM
        DllExport WORD CalcChkSum(BYTE *pByte, DWORD bufSize);


        // NOTE: call function with set==FALSE, if you will manipulate
        //       state of IC only; changes will be update
        //       with next call (set==TRUE) or if you call a function like SetVpp()
        // newIC4=oldIC4 & value
        DllExport void AndIC4(BYTE value, BOOL set=TRUE);

        // newIC5=oldIC5 & value
        DllExport void AndIC5(BYTE value, BOOL set=TRUE);

        // newIC4=oldIC4 | value
        DllExport void OrIC4(BYTE value, BOOL set=TRUE);

        // newIC5=oldIC4 | value
        DllExport void OrIC5(BYTE value, BOOL set=TRUE);

        // change Port: 0->278 1->378 2->3BC
        // return active Port-adr.
        // if you will only read the Port-adr., call argument > 2
        DllExport WORD  setPort(BYTE);

        // call with TRUE, if MF (4538) select for using
        DllExport void UseMF(BOOL useMf);
        
        // return TRUE, if MF select for using
        DllExport BOOL GetMFSelection();

        // if wait_type=FALSE: same to us_delay(300)   return always TRUE
        // if wait_type=TRUE : wait for signal Pin9 IC6B (timeout avialable --> return FALSE)       
        // NOTE: if changePins==TRUE --> manipulate IC4 (VPP=0; /CE=1) with return
        DllExport BOOL GetMFBit(BOOL wait_type=FALSE, BOOL changePins=TRUE);

        // same to Sleep(ticks)
        DllExport void ms_delay(unsigned short ticks);

        // if ticks=0: only function-call & return
        // if ticks=1: only one call of inport(Base+1)
        // if ticks>1: call ticks*get_delay()*get_delay() x inport(Base+1)
        // NOTE: one inport-call should wait about 1us
        DllExport void us_delay(unsigned short ticks);
        
        // read Data from IC1 HC299
        DllExport BYTE GetData();

        // read Data from internal Latch of IC1 HC299
        DllExport BYTE GetDataIntern();

        // read Byte from Port BA+1  BA: 278,378 or 3BC
        DllExport BYTE InportB();

        // put WORD to IC2+IC3 (HC595)
        DllExport void PutAdr(WORD putAdr);

        // put BYTE to IC1 (HC299)
        DllExport void PutData(BYTE out_Data);

        // put BYTE to IC5 (HC595)
        DllExport void PutIC5(BYTE putData);

        // put BYTE to IC4 (HC595)
        DllExport void PutIC4(BYTE putData);

        // set adress A0-A18 to IC2,IC3+IC5
        DllExport void setAdress(DWORD adress);

        // set internal delay-member (change acess-speed of LPT-clocking)
        DllExport BOOL set_delay(BYTE idelay);

        // return value of internal delay-member
        DllExport BYTE get_delay();
        
        // set VPP to T12_75, T21 or T25
        DllExport void SetVpp(BYTE vppType);

        // set Vcc to 5V(FALSE) or 6.25V(TRUE)
        DllExport void SetVcc(BOOL highVcc);
        
        // (re)set Vpp-PIN IC4-Pin1
        DllExport void SwitchVpp(BOOL bVpp);

        // (re)set /CE-PIN IC4-Pin3
        DllExport void SwitchCE(BOOL bCE)  ;

        // (re)set /OE-PIN IC4-Pin4
        DllExport void SwitchOE(BOOL bOE)  ;

        // return TRUE if fsize valid for IC-Type
        // if return=FALSE: in pStr is an error-text
        DllExport BOOL CheckICSize(WORD ICType, long fsize, CString fname, PCHAR& pStr);

        // return (size-1)/lastAdr. for IC-Type
        // return 0 if IC-Type unknown (objText give some error-infos back)
        DllExport DWORD GetLastAdress(WORD ICType, PCHAR& pText);

#endif
