#include "data.h"
#include "..\..\epro_dll\epro_dll.h"


#include "data.h"
#include "conio.h"

#define DELAY_PULSE 2	//1..x value to manipulate CLK in Source-text

// A16=CS       5P
// A17=Clk      VEN=(*PE/NC)
// A18=Din      XOE=ORG
// D0 =Dout     GND

// #####################################################

void ClockLO()
{
  AndIC5(BYTE(~CLK)); //A17=0
  us_delay(DELAY_PULSE);
}

void ClockHI()
{
  OrIC5(CLK);       //A17=1
  us_delay(DELAY_PULSE);
}

void LowBit()
{
    AndIC5(BYTE(~DI), FALSE); //A18=0
    ClockLO();
    ClockHI();
    ClockLO();
}

void HighBit()
{
    OrIC5(BYTE(DI), FALSE); //A18=1
    ClockLO();
    ClockHI();
    ClockLO();
}

void StartBit()
{
    AndIC5(BYTE(~CS), FALSE);
    AndIC5(BYTE(~DI), FALSE);	
	ClockLO();
    OrIC5(BYTE(CS));	
	ClockLO();
	HighBit();
}

void LowChip()
{
    AndIC5(BYTE(~DI), FALSE);	
    ClockLO();
    AndIC5(BYTE(~CS), FALSE);	
    ClockLO();
    OrIC5(BYTE(CS), FALSE);	
    ClockLO();
}


void DisableChip()
{
    AndIC5(BYTE(~CS), FALSE);
    AndIC5(BYTE(~CLK),FALSE);
    AndIC5(BYTE(~DI));		//CS=0 DI=0 CLK=0
}

void OutAdr(BYTE Anz,WORD Adr) //MSB to LSB
{
    WORD binear=0;
    BYTE lauf=0;
    if (Anz==7) binear=128; else binear=256; //7=128*16Bit else 256*8Bit
    
    for (lauf=0; lauf<=Anz;lauf++)
    {
		if ((Adr & binear)==binear) HighBit(); else  LowBit();
		binear=WORD(binear/2);
    }
    AndIC5(BYTE(~DI),FALSE);
}

BYTE GetSerialByte()	//get Q7-0
{
    BYTE lauf=0,recievedata=0,binear=0x80;
    BYTE Dread=0;

    AndIC5(BYTE(~DI),FALSE);
    for (lauf=0; lauf<=7;lauf++)	//Q7-0
    {
       	ClockHI();
		us_delay(DELAY_PULSE);	
		ClockLO();
		us_delay(DELAY_PULSE);	
        Dread=GetData();
		if ((Dread&DO)==DO) recievedata=BYTE(recievedata+binear); //DO=1
		binear=BYTE(binear/2);
    }
    return recievedata;
}

/*
WORD GetSerialWord()	//get Q15-0
{
    WORD lauf=0,recievedata=0,binear=0x8000;
    BYTE Dread=0;

    AndIC5(BYTE(~DI),FALSE);
    for (lauf=0; lauf<=15;lauf++)	//Q15-0
    {
        ClockHI();
		us_delay(DELAY_PULSE);	
		ClockLO();
		us_delay(DELAY_PULSE);	
        Dread=GetData();
		if ((Dread&DO)==DO) recievedata=WORD(recievedata+binear); //DO=1
		binear=WORD(binear/2);
    }
	return recievedata;
}
*/

void PutSerialByte(BYTE Datum)	//get Q7-0
{
    BYTE lauf=0,recievedata=0,binear=0x80;

    for (lauf=0; lauf<=7;lauf++)	//Q7-0
    {
		if ((Datum & binear)==binear) HighBit(); else   LowBit();
		binear=BYTE(binear/2);
    }
}

/*
void PutSerialWord(WORD Datum)	//get Q15-0
{
    WORD lauf=0,binear=0x8000;
	WORD transmitdata=Datum;
	

    for (lauf=0; lauf<=15;lauf++)	//Q7-0
    {
		if ((transmitdata & binear)==binear) HighBit(); else   LowBit();
		binear=WORD(binear/2);      
    }
}
*/

void Enable8()
{	//1 00 11xxx xxxx
  AndIC4(BYTE(~ORG));
  StartBit();		//   . 1
  LowBit();			//Opc. 0
  LowBit();			//Opc. 0
  OutAdr(8,0x1FF);	//send 11xxx xxxx
}

/*
void Enable16()
{	//1 00 11xx xxxx
  OrIC4(ORG);
  StartBit();		//   . 1
  LowBit();			//Opc. 0
  LowBit();			//Opc. 0
  OutAdr(7,0xFF);	//send 11xx xxxx
}
*/

void Disable8()
{	//1 00 00xxx xxxx
  AndIC4(BYTE(~ORG));
  StartBit();		//   . 1
  LowBit();			//Opc. 0
  LowBit();			//Opc. 0
  OutAdr(8,0x00);	//send 00xxx xxxx
}

/*
void Disable16()
{	//1 00 00xx xxxx
  OrIC4(ORG);
  StartBit();		//   . 1
  LowBit();			//Opc. 0
  LowBit();			//Opc. 0
  OutAdr(7,0x00);	//send 00xx xxxx
}
*/

BOOL IsReady()
{
	WORD Limit=4000;

    AndIC5(BYTE(~DI),FALSE);
    OrIC5(CS);
	while(Limit--!=0)
	{
	  us_delay(4*DELAY_PULSE);
	  if ((GetData()&DO)==DO) return TRUE;
	}
	return FALSE;
}

//access-function

BOOL WriteByte(WORD Adr,BYTE Datum)
{	//1 01 A8-0 -> Q7-0
  AndIC4(BYTE(~ORG), FALSE);
  OrIC5(CS, FALSE);
  //Enable8();			//call this function extern
  StartBit();			//   . 1
  LowBit();				//Opc. 0
  HighBit();			//Opc. 1
  
  // special mem-struct for these types
  //if ((EEProm_Type==AT93c56) || (EEProm_Type==CAT93c56)) 
  //{		
  //  if (EEProm_Type==AT93c56) OutAdr(8,Adr^1);		//send A8-0
  //  else	//CAT93c56
  //  {
  //	  if (Adr % 2 == 0) OutAdr(8,Adr - Adr/2 + 0x80);	//send A8-0;
  //		else OutAdr(8,(Adr - 1)/2);	//send A8-0;
  //  }
  //}
  // else 
  //
  OutAdr(8,Adr);			//send A8-0
  PutSerialByte(Datum);	//put Q7-0
  LowChip();
  us_delay(DELAY_PULSE);
  return IsReady();
}

/*
BOOL WriteWord(WORD Adr,WORD Datum)
{	//1 01 A7-0 -> Q15-0
  OrIC4(ORG);
  OrIC5(CS, FALSE);
  //Enable16();			//call this function extern
  AndIC5(DI);
  StartBit();			//   . 1
  LowBit();				//Opc. 0
  HighBit();			//Opc. 1
  OutAdr(7,Adr);		//send A7-0
  PutSerialWord(Datum);	//put Q15-0
  LowChip();			//toggle CS
  us_delay(DELAY_PULSE);
  return IsReady();
}
*/

BYTE ReadByte(WORD Adr)
{	//1 10 A8-0 <-Q7-0
  AndIC4(BYTE(~ORG));
  StartBit();
  HighBit();
  LowBit();
  // special mem-struct for these types
  //if ((EEProm_Type==AT93c56) || (EEProm_Type==CAT93c56)) 
  //{		
  //  if (EEProm_Type==AT93c56) OutAdr(8,Adr^1);		//send A8-0
  //  else	//CAT93c56
  //  {
  //	  if (Adr % 2 == 0) OutAdr(8,Adr - Adr/2 + 0x80);	//send A8-0;
  //		else OutAdr(8,(Adr - 1)/2);	//send A8-0;
  //  }
  //}
  // else 
  //
  OutAdr(8,Adr);			//send A8-0
  return GetSerialByte();		//get Q7-0
}

/*
WORD ReadWord(WORD Adr)
{	//1 10 A7-0 <-Q7-0
  OrIC4(ORG);
  StartBit();
  HighBit();
  LowBit();
  OutAdr(7,Adr);		//send A7-0
  return GetSerialWord();		//get Q15-0
}
*/

//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////


WORD ReadByteAll(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    AndIC4(BYTE(~ORG));
    ms_delay(2);	
    char tmp[200];	
    if (pDef==NULL) return 0;

    if (pApp) pApp->DoWaitCursor(1);
    pInfo->SetWindowText("reading...");
    pInfo->SendMessage(WM_PAINT);

    DWORD offs=pDef->selStart;
    DWORD endRead=pDef->selSize-offs;

    if (endRead>255) { MessageBox(NULL, "can't read more than 255 bytes", "Info:", MB_ICONHAND); return 0;}

    CString str;
    for (DWORD adresse=0; adresse <= endRead; adresse++)
    {
        str.Format("adr: 0x%lx",adresse+offs);
        pCnt->SetWindowText(str);
        pCnt->SendMessage(WM_PAINT);
		pByte[adresse]=ReadByte(WORD(adresse+offs));
    	ClockLO();
    	LowChip();
    }
    DisableChip();
    DWORD chsum=CalcChkSum(pByte, endRead);
    wsprintf(tmp,"read IC to buffer ( %lu bytes ) - [#%lX]",DWORD(adresse),long(chsum));
    pInfo->SetWindowText(LPCSTR(tmp));   //show last adress

    pInfo->SendMessage(WM_PAINT);
    pCnt->SendMessage(WM_PAINT);

    if (pApp) pApp->DoWaitCursor(-1);

    return WORD(endRead);
}


/*
WORD ReadWordAll(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    WORD recievedata=0;
    OrIC4(ORG);
    ms_delay(2);

    char tmp[200];	
    if (pDef==NULL) return 0;

    if (pApp) pApp->DoWaitCursor(1);
    pInfo->SetWindowText("reading...");
    pInfo->SendMessage(WM_PAINT);

    DWORD offs=pDef->selStart;
    DWORD endRead=pDef->selSize-offs;

    if (endRead>255) { MessageBox(NULL, "can't read more than 255 bytes", "Info:", MB_ICONHAND); return 0;}

    CString str;
    for (DWORD adresse=0; adresse <= DWORD(endRead/2); adresse++)   //128 Words
    {
        str.Format("adr: 0x%lx",adresse+offs);
        pCnt->SetWindowText(str);
        pCnt->SendMessage(WM_PAINT);
        recievedata=ReadWord(WORD(adresse)); //16bit
		pByte[2*adresse]  =HIGHBYTE(recievedata);  //low
        if ( (2*adresse+1)<=endRead) pByte[2*adresse+1]=LOWBYTE(recievedata);   //high
    	ClockLO();
    	LowChip();
    }
    DisableChip();
    DWORD chsum=CalcChkSum(pByte, endRead);
    wsprintf(tmp,"read IC to buffer ( %lu bytes ) - [#%lX]",DWORD(adresse),long(chsum));
    pInfo->SetWindowText(LPCSTR(tmp));   //show last adress

    pInfo->SendMessage(WM_PAINT);
    pCnt->SendMessage(WM_PAINT);

    if (pApp) pApp->DoWaitCursor(-1);

    return WORD(endRead);
}
*/

WORD VerifyByteAll(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    WORD lauf=0,lauf2=0;
    BYTE recievedata=0;

    AndIC4(BYTE(~ORG));
    ms_delay(2);

    char tmp[200];	
    char bigInfo[500];

    if (pDef==NULL) return 0;

    if (pApp) pApp->DoWaitCursor(1);
    pInfo->SetWindowText("compare...");
    pInfo->SendMessage(WM_PAINT);

    DWORD offs=pDef->selStart;
    DWORD endCompare=pDef->selSize-offs;

    if (endCompare>255) { MessageBox(NULL, "can't compare more than 255 bytes", "Info:", MB_ICONHAND); return 0;}

    CString str;
    for (DWORD adresse=0; adresse <= endCompare; adresse++)
    {
        str.Format("adr: 0x%lx",adresse+offs);
        pCnt->SetWindowText(str);
        pCnt->SendMessage(WM_PAINT);
		recievedata=ReadByte(WORD(adresse+offs));
    	ClockLO();
    	LowChip();
    	if (pByte[adresse]!=recievedata) 
        {
            wsprintf(bigInfo,"error at adr: 0x%lX\r\nread: 0x%lX\tbuffer: 0x%lX",adresse+offs,DWORD(BYTE(recievedata)),DWORD(pByte[adresse]));
            pInfo->SetWindowText(bigInfo);
            pInfo->SendMessage(WM_PAINT);
         	MessageBeep(0);
         	MessageBox(NULL, bigInfo, NULL, MB_ICONHAND);
            DisableChip();
            wsprintf(tmp,"compare BAD"); 	         
	    	pCnt->SetWindowText(tmp);   //show last adress}
            return WORD(adresse);
        }

    }
    DisableChip();
    DWORD chsum=CalcChkSum(pByte, endCompare);
    wsprintf(bigInfo,"compare OK ( %lu bytes ) - [#%lX]",DWORD(adresse),long(chsum));
    pInfo->SetWindowText(LPCSTR(bigInfo));   //show last adress
    wsprintf(tmp,"compare: %lX",DWORD(endCompare)); 	         
    pCnt->SetWindowText(tmp);   //show last adress}

    pInfo->SendMessage(WM_PAINT);
    pCnt->SendMessage(WM_PAINT);

    if (pApp) pApp->DoWaitCursor(-1);

    return WORD(endCompare);
}

/*
WORD VerifyWordAll(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
  WORD lauf=0,recievedata=0;

  OrIC4(ORG);
  ms_delay(2);
  ReadWord(0);
  for (lauf=0; lauf<=127;lauf++)	//128 Words
  {
    	recievedata=ReadWord(lauf);
    	if (0!=HIGHBYTE(recievedata)) 
		{ 
			return lauf;
		}
    	if (1!=LOWBYTE(recievedata)) 
		{ 
			return lauf;
		}
    	ClockLO();
    	LowChip();
  }
  DisableChip();
  return 128;
}
*/

int WriteByteAll(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    AndIC4(BYTE(~ORG));
    OrIC4(BYTE(~0x8));
    ms_delay(2);
    Enable8();	//for WriteByte()

    char tmp[200];	
    char bigInfo[500];

    if (pDef==NULL) return 0;

    if (pApp) pApp->DoWaitCursor(1);
    pInfo->SetWindowText("write...");
    pInfo->SendMessage(WM_PAINT);

    DWORD offs=pDef->selStart;
    DWORD endWrite=pDef->selSize-offs;

    if (endWrite>255) { MessageBox(NULL, "can't write more than 255 bytes", "Info:", MB_ICONHAND); return 0;}

    CString str;
    BOOL success=FALSE;
    for (DWORD adresse=0; adresse <= endWrite; adresse++)
    {
        str.Format("adr: 0x%lx",adresse+offs);
        pCnt->SetWindowText(str);
        pCnt->SendMessage(WM_PAINT);
        success=WriteByte(WORD(adresse+offs),pByte[adresse]);
   	    ClockLO();
   	    LowChip();
		if( (!success) ) //|| (pByte[adresse]!=ReadByte(WORD(adresse+offs))) )
        {
            wsprintf(bigInfo,"error at adr: 0x%lX",adresse+offs);
            pInfo->SetWindowText(bigInfo);
            pInfo->SendMessage(WM_PAINT);
         	MessageBeep(0);
         	MessageBox(NULL, bigInfo, NULL, MB_ICONHAND);
            DisableChip();
            wsprintf(tmp,"write BAD"); 	         
	    	pCnt->SetWindowText(tmp);   //show last adress}
            return WORD(adresse);
        }
    	ClockLO();
    	LowChip();
    }
    DisableChip();
    DWORD chsum=CalcChkSum(pByte, endWrite);
    wsprintf(bigInfo,"write OK ( %lu bytes ) - [#%lX]",DWORD(adresse),long(chsum));
    pInfo->SetWindowText(LPCSTR(bigInfo));   //show last adress
    wsprintf(tmp,"write: %lX",DWORD(endWrite)); 	         
    pCnt->SetWindowText(tmp);   //show last adress}

    pInfo->SendMessage(WM_PAINT);
    pCnt->SendMessage(WM_PAINT);

    if (pApp) pApp->DoWaitCursor(-1);

    return WORD(endWrite);
}

/*
int WriteWordAll(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
  int lauf=0;

  OrIC4(ORG);
  ms_delay(2);
  Enable16();	//for WriteWord()

  for (lauf=0; lauf<=127;lauf++)	//128 WORDs
  {
    	//if(WriteWord(WORD(lauf),WORD(256*pByte[lauf*2]+pByte[lauf*2+1]))!=TRUE) 
		{ 
			return -lauf;   //sign an error
		}
    	ClockLO();
    	LowChip();
  }
  DisableChip();
  return 128;
}
*/