#include "epro_ext.h"
#include "93c56\data.h"
#include "..//epro_dll//epro_dll.h"
        
BOOL WINAPI DllMain( HINSTANCE /*hModule*/, 
                       DWORD  ul_reason_for_call, 
                       PVOID /*lpReserved*/
					 )
{
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH: OutputDebugString("\nDLL_PROCESS_ATTACH\n"); break;
        case DLL_THREAD_ATTACH:  OutputDebugString("\nDLL_THREAD_ATTACH:\n"); break;
        case DLL_PROCESS_DETACH: OutputDebugString("\nDLL_PROCESS_DETACH\n"); break;
        case DLL_THREAD_DETACH:  OutputDebugString("\nDLL_THREAD_DETACH\n");  break;
        default: OutputDebugString("\nunknown param\n"); return FALSE;
    }
    return TRUE;
}

/*********************************************************/
char* GetDLLVersion()
{
    return ThisDLLVersion;
}

/*********************************************************/
void SetICType(WORD newType)
{
    //init here HW for given IC-Type
    switch (newType)
    {
        
        case T93c56: PutIC5(0);OrIC5(0x20); OrIC5(0x80); break;
        default:break;
    };

}

/*********************************************************/
TICInfo* InitICList()
{
    static BOOL first=TRUE;
    TICInfo *pHead=NULL;

    if (first)
    {
        //add here new types
        TICInfo *pDef=NULL;
        for (int x=0; x<1; x++)
        {
            pDef=MallocICMem();
            if (pDef)
            {
                //store head of list
                if (pHead==NULL) pHead=pDef;
                switch(x)
                {
                    case 0: pDef->IcType=T93c56;
                            sprintf(pDef->devText,"93c56");
                            pDef->devSize=255; //for 256 Bytes
                            break;
                    default:pDef->IcType=0;
                            sprintf(pDef->devText,"??");
                            pDef->devSize=0;
                }
                pDef->devVpp=T12_75;
                pDef->devVccWrite=FALSE;    //use 5V
                pDef->devVccRead=FALSE;     //use 5V
                pDef->devStart=0;

                pDef->selVpp=pDef->devVpp;
                pDef->selVccWrite=pDef->devVccWrite;
                pDef->selVccRead=pDef->devVccRead;
                pDef->selStart=pDef->devStart;
                pDef->selSize=pDef->devSize;

                pDef->dw1=0;        // --> defined for future-use
                pDef->dw2=0;        // --> can be used for new types
                pDef->dw3=0;        
                pDef->dw4=0;        
                pDef->b1=0;
                pDef->b2=0;
                pDef->text[0]=0;
                pDef->buf[0]=0;
                pDef->usedBuf=0;
            }
            AddIcDefinition(pDef);
        }
        first=FALSE;
    }
    return pHead;
}

/*********************************************************/
DWORD ReadIC(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    if ( (pCnt==NULL)||(pInfo==NULL)) return 0;
    if (pByte==NULL) return 0;


    DWORD ret=0;
    if (IcType==T93c56) ret=ReadByteAll(pByte, pDef, pApp, pCnt, pInfo, IcType);
     else MessageBox(NULL, "Type not supported", "Info:", MB_ICONHAND);
    
    return ret;
}

/*********************************************************/
BOOL CompareIC(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType, BOOL BlankCheck)
{
    BOOL ret=FALSE;
    //put here code for new IC-Types
    if (BlankCheck)
    {
        MessageBox(NULL, "not implemented", "Info:", MB_ICONHAND);
    }
    else
    {
        if (IcType==T93c56) ret=VerifyByteAll(pByte, pDef, pApp, pCnt, pInfo, IcType);
         else MessageBox(NULL, "not implemented", "Info:", MB_ICONHAND);
    }
    return ret;
}

/*********************************************************/
BOOL WriteIC(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    BOOL ret=FALSE;
    //put here code for new IC-Types
    if (IcType==T93c56) ret=WriteByteAll(pByte, pDef, pApp, pCnt, pInfo, IcType);
     else MessageBox(NULL, "not implemented", "Info:", MB_ICONHAND);
    return ret;
}

/*********************************************************/
BOOL  EraseIC  (BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    BOOL ret=FALSE;
    //put here code for new IC-Types
    MessageBox(NULL, "not implemented", "Info:", MB_ICONHAND);
    return ret;
}

/*********************************************************/
BOOL SpecialIC(BYTE *pByte, TICInfo *pDef, CWinApp *pApp, CWnd *pCnt, CWnd *pInfo, WORD IcType)
{
    BOOL ret=FALSE;
    //put here code for new IC-Types
    MessageBox(NULL, "not implemented", "Info:", MB_ICONHAND);
    return ret;
}